﻿
using TenCrowns.GameCore;

namespace ExtendedInheritanceScreen
{
    internal class ExtendedInheritanceScreenPlayer : Player
    {
        public ExtendedInheritanceScreenPlayer() : base()
        {
            return;
        }

        protected override void doFamilies()
        {
            if (game().isCharacters())
            {
                foreach (FamilyType eLoopFamily in getFamilies())
                {
                    if (countActiveCharacters(null, eLoopFamily) < 4)
                    {
                        if (hasFounder())
                        {
                            Character pCharacter1 = game().createNewCharacter((40 + game().randomNext(10)), getPlayer(), infos().Globals.MALE_GENDER, NameType.NONE, eLoopFamily);
                            pCharacter1.fillValues(3, TraitType.NONE, null);
                            if (hasFounder())
                            {
                                founder().addChild(pCharacter1.getID());
                                founder().setRetired(true);
                            }
                            else
                            {
                                leader().addChild(pCharacter1.getID());
                            }
                            Character pCharacter2 = game().createNewCharacter((40 + game().randomNext(10)), getPlayer(), infos().Globals.FEMALE_GENDER, NameType.NONE, eLoopFamily);
                            pCharacter2.fillValues(3, TraitType.NONE, null);
                            pCharacter1.marry(pCharacter2, false);
                            Character pCharacter3 = game().createNewCharacter((infos().Globals.ADULT_AGE + game().randomNext(10)), getPlayer(), (GenderType)(game().randomNext((int)infos().gendersNum())), NameType.NONE, eLoopFamily);
                            pCharacter3.fillValues(3, TraitType.NONE, null);
                            pCharacter3.setMotherID(pCharacter2.getID());
                            pCharacter3.setFatherID(pCharacter1.getID());
                            pCharacter1.addChild(pCharacter3.getID());
                            pCharacter2.addChild(pCharacter3.getID());
                            Character pCharacter4 = game().createNewCharacter((infos().Globals.ADULT_AGE + game().randomNext(10)), getPlayer(), (GenderType)(game().randomNext((int)infos().gendersNum())), NameType.NONE, eLoopFamily);
                            pCharacter4.fillValues(3, TraitType.NONE, null);
                            pCharacter4.setMotherID(pCharacter2.getID());
                            pCharacter4.setFatherID(pCharacter1.getID());
                            pCharacter1.addChild(pCharacter4.getID());
                            pCharacter2.addChild(pCharacter4.getID());
                            setFamilyHeadID(eLoopFamily, pCharacter1.getID());
                            for (TraitType eLoopTrait = 0; eLoopTrait < infos().traitsNum(); eLoopTrait++)
                            {
                                if (infos().trait(eLoopTrait).mzType == "TRAIT_FAMILY_LINE")
                                {
                                    pCharacter1.addTrait(eLoopTrait);
                                    pCharacter2.addTrait(eLoopTrait);
                                    pCharacter3.addTrait(eLoopTrait);
                                    pCharacter4.addTrait(eLoopTrait);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
